;:----------------- dslink
;------------------
;assemble via TASM 5.0 or similar
;MCOM32.BAT
; @ echo off
; tasm32 /ml %1 %2 %3 %4 %5
; IF exist %1.RC     brcc32 %1 %2 %3 %4 %5
; IF exist %1.RC     tlink32 %1,%1,,,,%1 -x -Tpe -ap -V4.0
; IF NOT exist %1.RC tlink32 %1,%1,,,,   -x -Tpe -ap -V4.0
; del %1.obj
;------------------
.386
.model flat,STDCALL
.code
locals
includelib \talky\tasm32\import32.lib
;---
extrn ExitProcess       :proc
extrn GetStdHandle      :proc
extrn GetTickCount      :proc
;---
extrn CreateFileA       :proc
extrn GetFileSize       :proc
extrn ReadFile          :proc
extrn WriteFile         :proc
extrn CloseHandle       :proc
extrn GlobalAlloc       :proc
extrn GlobalFree        :proc
;---
extrn WSAStartup        :proc
extrn WSACleanup        :proc
extrn socket            :proc
extrn htons             :proc
extrn setsockopt        :proc
extrn ioctlsocket       :proc
extrn bind              :proc
extrn connect           :proc
extrn recvfrom          :proc
extrn recv              :proc
extrn send              :proc
extrn sendto            :proc
extrn shutdown          :proc
extrn closesocket       :proc
;---
WSADESCRIPTION_LEN  equ 256
WSASYS_STATUS_LEN   equ 128
INADDR_ANY          equ 000000000h
INADDR_LOOPBACK     equ 07F000001h
INADDR_BROADCAST    equ 0FFFFFFFFh
INADDR_NONE         equ 0FFFFFFFFh
FIONBIO             equ 8004667Eh
FIONSYNC            equ 8004667Dh
FIONREAD            equ 4004667Fh
SD_RECEIVE          equ 0  ;Shutdown receive operations.
SD_SEND             equ 1  ;Shutdown send operations.
SD_BOTH             equ 2  ;Shutdown both send and receive operations.
SOCK_STREAM         equ 1
SOCK_DGRAM          equ 2
SOCK_RAW            equ 3
SOCK_RDM            equ 4
SOCK_SEQPACKET      equ 5
SO_DEBUG               equ 00001h
SO_ACCEPTCONN          equ 00002h
SO_REUSEADDR           equ 00004h
SO_KEEPALIVE           equ 00008h
SO_DONTROUTE           equ 00010h
SO_BROADCAST           equ 00020h
SO_USELOOPBACK         equ 00040h
SO_LINGER              equ 00080h
SO_OOBINLINE           equ 00100h
SOL_SOCKET             equ 0FFFFh
SO_DONTLINGER          equ not SO_LINGER
SO_SNDBUF              equ 01001h
SO_RCVBUF              equ 01002h
SO_SNDLOWAT            equ 01003h
SO_RCVLOWAT            equ 01004h
SO_SNDTIMEO            equ 01005h
SO_RCVTIMEO            equ 01006h
SO_ERROR               equ 01007h
SO_TYPE                equ  01008h
TCP_NODELAY            equ 00001h
AF_UNSPEC              equ 0
AF_UNIX                equ 1
AF_INET                equ 2
PF_UNSPEC              equ AF_UNSPEC
PF_UNIX                equ AF_UNIX
PF_INET                equ AF_INET
INVALID_SOCKET         equ NOT 0
SOCKET_ERROR           equ -1
SOCKET_BUFFER_SIZE     equ 512
;---
STD_INPUT_HANDLE        equ -10
STD_OUTPUT_HANDLE       equ -11
MAX_PATH                equ 260
FILE_ATTRIBUTE_NORMAL   equ 080h
CREATE_ALWAYS           equ 2
OPEN_EXISTING           equ 3
GENERIC_READ            equ 80000000h
GENERIC_WRITE           equ 40000000h
FILE_SHARE_READ         equ 1h
GMEM_FIXED              equ 0
GMEM_ZEROINIT           equ 40h
;------------------
;:----------------- Data
;------------------
.data
;------------------
align 4
 std_out        dd 0
 diskresult     dd 0
;------------------
 dslink_ip_addr dd 0
;------------------
 align 4
 wrchr_buf    db 0

 txt_hello db 'dsdump by nocash 2016',0dh,0ah,0

.code
;------------------
.data?
align 4
wsadata:
              dw ?                              ;000h wVersion
              dw ?                              ;002h wHighVersion
 wsadata_desc db WSADESCRIPTION_LEN + 1 dup (?) ;004h description string
 wsadata_stat db WSASYS_STATUS_LEN + 1 dup (?)  ;105h status info string
              dw ?                              ;186h max_sockets
              dw ?                              ;188h iMaxUdpDg
              dd ?                              ;18Ah ptr to user/vendor data (optional)
;---
 dw ?  ;alignment padding
align 4
.code
;------------------
find_ds:
 push 0          ;protocol (none specified)     ;\
 push SOCK_DGRAM ;type (datagram)               ;
 push PF_INET    ;address format                ; create broadcast socket
 call socket                                    ;
;cmp  eax,INVALID_SOCKET                        ;
;je   short @@error                             ;
 mov  dword ptr [@@broadcast_socket],eax        ;/
 push 4  ;sizeof @@optval             ;optlen   ;\
 push offset @@optval                 ;optval   ;
 push SO_BROADCAST                    ;optname  ; set broadcast socket
 push SOL_SOCKET                      ;level    ;
 push dword ptr [@@broadcast_socket]  ;socket   ;
 call setsockopt                                ;
;cmp  eax,SOCKET_ERROR                          ;
;je   short @@error                             ;/
 mov  word ptr [@@sockaddr_s+00h],AF_INET   ;family             ;\
 mov  word ptr [@@sockaddr_rs+00h],AF_INET  ;family             ;
 push 17491                                 ;port 17491         ; init socket
 call htons     ;host-to-network byte-order                     ; port/addr's
 mov  word ptr [@@sockaddr_s+02h],ax        ;port 17491         ;
 mov  word ptr [@@sockaddr_rs+02h],ax       ;port 17491         ;
 mov  dword ptr [@@sockaddr_s+04h],INADDR_BROADCAST ;addr       ;
 mov  dword ptr [@@sockaddr_rs+04h],INADDR_ANY      ;addr       ;/
 push 0          ;protocol (none specified)     ;\
 push SOCK_DGRAM ;type (datagram)               ;
 push PF_INET    ;address format                ; create receive socket
 call socket                                    ;
;cmp  eax,INVALID_SOCKET                        ;
;je   short @@error                             ;
 mov  dword ptr [@@receive_socket],eax          ;/
 push 10h   ;size of @@sockaddr_xx    ;namelen  ;\
 push offset @@sockaddr_rs            ;addr     ;
 push dword ptr [@@receive_socket]    ;socket   ;
 call bind                                      ;
;cmp  eax,SOCKET_ERROR                          ;
;je   short @@error                             ;/
 mov  dword ptr [@@opt],1 ;nonblocking          ;\
 push offset @@opt                    ;argp     ;
 push FIONBIO                         ;cmd      ;
 push dword ptr [@@receive_socket]    ;socket   ;
 call ioctlsocket                               ;/
 ;--- ---
 call GetTickCount                      ;\
 mov  dword ptr [@@next_try_time],eax   ;/
 mov  dword ptr [@@retry_count],10      ;-
@@scan_lop:
 call GetTickCount                      ;\
 sub  eax,dword ptr [@@next_try_time]   ; check if (re-)try time
 jl   short @@not_yet_send_resend       ;/
 dec  dword ptr [@@retry_count]         ;\give up after max retries
 jz         @@scan_timeout              ;/
 add  dword ptr [@@next_try_time],150   ;-next (re-)try time (150ms)
 push 10h   ;size of @@sockaddr_xx    ;tolen    ;\
 push offset @@sockaddr_s             ;to       ;
 push 0                               ;flags    ;
 push 6               ;len("dsdump")  ;dtalen   ; send/resend broadcast message
 push offset @@mess   ;"dsdump"       ;dta      ;
 push dword ptr [@@broadcast_socket]  ;socket   ;
 call sendto                                    ;
call wrdot
call wrhexeax
call wrcrlf
;cmp  eax,SOCKET_ERROR                          ;
;je   short @@error                             ;/
@@not_yet_send_resend:
 mov  dword ptr [@@fromlen],10h ;size of @@sockaddr_xx
 push offset @@fromlen ;indirect here ;fromlen  ;\
 push offset @@sockaddr_remote        ;from     ;
 push 0                               ;flags    ;
 push @@recv_buf_len                  ;dstlen   ;
 push offset @@recv_buf               ;dst      ;
 push dword ptr [@@receive_socket]    ;socket   ;
 call recvfrom     ;out: len/error              ;
 cmp  eax,SOCKET_ERROR  ;no reply yet ;\        ;
 je   short @@scan_lop                ; buf len ;
call wrdot
 cmp  eax,6             ;len too short;         ;
 jb         @@scan_lop                ;/        ;
 cmp  dword ptr [@@recv_buf+0],'pmud' ;\        ;
 jne        @@scan_lop                ; "dumpds";
 cmp  word ptr [@@recv_buf+4],'sd'    ;         ;
 jne        @@scan_lop                ;/        ;/
 mov  eax,dword ptr [@@sockaddr_remote+4] ;addr ;\okay, found nds!
 jmp  short @@scan_done_eax                     ;/
;--- ---
@@scan_timeout:
 mov  eax,INADDR_NONE
@@scan_done_eax:                                        ;\apply IP addr
 mov  dword ptr [dslink_ip_addr],eax                    ;/
 push SD_SEND                         ;how      ;\      ;\
 push dword ptr [@@receive_socket]    ;socket   ;       ;
 call shutdown                                  ;/      ; close receive socket
 push dword ptr [@@receive_socket]    ;socket   ;\      ;
 call closesocket                               ;/      ;/
 push SD_SEND                         ;how      ;\      ;\
 push dword ptr [@@broadcast_socket]  ;socket   ;       ;
 call shutdown                                  ;/      ; close broadcast socket
 push dword ptr [@@broadcast_socket]  ;socket   ;\      ;
 call closesocket                               ;/      ;/
 ret    ;out: [dslink_ip_addr]
;---
.data
align 4
 @@sockaddr_s:             ;\
  dw 0         ;00h family ;
  dw 0         ;02h port   ; 10h bytes
  db 4 dup (0) ;04h addr   ;
  db 8 dup (0) ;08h zero   ;/
 @@sockaddr_rs:            ;\
  dw 0         ;00h family ;
  dw 0         ;02h port   ; 10h bytes
  db 4 dup (0) ;04h addr   ;
  db 8 dup (0) ;08h zero   ;/
 @@sockaddr_remote:        ;\
  dw 0         ;00h family ;
  dw 0         ;02h port   ; 10h bytes
  db 4 dup (0) ;04h addr   ; <-- NDS IP will be automatically inserted here
  db 8 dup (0) ;08h zero   ;/
 @@broadcast_socket dd 0
 @@receive_socket   dd 0
 @@opt              dd 1
 @@fromlen          dd 10h
 @@optval           dd 1
 @@retry_count      dd 10
 @@next_try_time    dd 0
 @@mess             db 'dsdump'
.data?
 @@recv_buf_len equ 100h
 @@recv_buf db @@recv_buf_len dup (?)
.code
;------------------
begin_tcp:
 push 0          ;protocol (none specified)     ;\
 push SOCK_STREAM;type (stream)                 ;
 push AF_INET    ;address format                ; create transmit socket
 call socket                                    ;
;cmp  eax,INVALID_SOCKET                        ;
;je   short @@error                             ;
 mov  dword ptr [transmit_socket],eax           ;/

 mov  word ptr [sockaddr_t+00h],AF_INET     ;family             ;\
 push 17491                                 ;port 17491         ; init socket
 call htons     ;host-to-network byte-order                     ; port/addr
 mov  word ptr [sockaddr_t+02h],ax          ;port 17491         ;
 mov  eax,dword ptr [dslink_ip_addr]        ;addr               ;
 mov  dword ptr [sockaddr_t+04h],eax        ;addr               ;/
 push 10h   ;size of @@sockaddr_xx    ;namelen  ;\
 push offset sockaddr_t               ;name     ;
 push dword ptr [transmit_socket]     ;socket   ;
 call connect                                   ;
;cmp  eax,SOCKET_ERROR                          ;
;je   short @@error                             ;/
 ret
;------------------
stop_tcp:
 push SD_SEND                         ;how      ;\      ;\
 push dword ptr [transmit_socket]     ;socket   ;       ;
 call shutdown                                  ;/      ; close transmit socket
 push dword ptr [transmit_socket]     ;socket   ;\      ;
 call closesocket                               ;/      ;/
 ret
;------------------
recv_filename:
 mov  esi,256                         ;dstlen   ;\
 mov  edi,offset response_buffer      ;dst      ;
 call recvall      ;out: len/error              ;/
 cmp  eax,SOCKET_ERROR                          ; check response
;je   short @@error                             ;
 cmp  eax,256  ;expect full 256-bytes           ;
 jne  short @@error                             ;
 cmp  dword ptr [response_datasize],0           ;
 jz   short @@no_more                           ;
 cmp  dword ptr [response_filename],'pmud'      ;
 jne  short @@error                             ;
 clc   ;okay
 ret
;---
@@no_more:
@@error:
 stc
 ret
;------------------
recv_filebody:
 mov  esi,dword ptr [response_datasize] ;dstlen
 mov  edi,dword ptr [databuffer]        ;dst
 call recvall
 ret
;------------------
recvall:   ;in: esi=len, edi=dst
@@recv_lop:
 push 0                               ;flags    ;\
 push esi                             ;dstlen   ;
 push edi                             ;dst      ;
 push dword ptr [transmit_socket]     ;socket   ; recv
 call recv         ;out: len/error              ;
        call wrhexeax
 cmp  eax,SOCKET_ERROR                          ;
 je   short @@error                             ;
 cmp  eax,0                                     ;
 jle  short @@error                             ;/
 add  edi,eax  ;dst                   ;dst+len  ;\
 sub  esi,eax  ;len                   ;dstlen   ; lop more
 ja   short @@recv_lop                          ;/
@@error:
 ret
;---
.data
align 4
 sockaddr_t:               ;\
  dw 0         ;00h family ;
  dw 0         ;02h port   ; 10h bytes
  db 4 dup (0) ;04h addr   ;
  db 8 dup (0) ;08h zero   ;/
align 4
 transmit_socket dd 0
 response_buffer db 256 dup (0)
 response_datasize equ response_buffer+0
 response_filename equ response_buffer+4
 databuffer dd 0
.code
;------------------
.code
;------------------
;:----------------- Standalone Video I/O
;------------------
wrchr:
 pusha
 mov  byte ptr [wrchr_buf],al
 push 0                    ;set to 0 in most cases
 push offset diskresult    ;pointer to number of read bytes
 push 1                         ;length
 push offset wrchr_buf          ;source
 push dword ptr ds:[std_out]    ;handle
 call WriteFile
 popa
 ret
;------------------
wrstr_edx:
@@lop:
 mov  al,byte ptr [edx]
 inc  edx
 cmp  al,00h
 jz   short @@done
 call wrchr
 jmp  short @@lop
@@done:
 ret
;------------------
skipstr_esi:
@@lop:
 lodsb
 cmp  al,00h
 jnz  short @@lop
 ret
;------------------
wrspc:
 push eax
 mov  al,20h
 call wrchr
 pop  eax
 ret
;------------------
wrdot:
 push eax
 mov  al,'.'
 call wrchr
 pop  eax
 ret
;------------------
wrcrlf:
 push eax
 mov  al,0dh
 call wrchr
 mov  al,0ah
 call wrchr
 pop  eax
 ret
;------------------
wr_decimal_al:
 pusha
 mov  ah,0      ;\
 mov  dl,100    ;
 div  dl        ; hundreds
 or   al,30h    ;
 call wrchr     ;/
 mov  al,ah ;remainder
 mov  ah,0
 mov  dl,10
 div  dl
 or   ax,3030h
 call wrchr     ;-tens
 mov  al,ah ;remainder
 call wrchr     ;-ones
 popa
 ret
;------------------
wrdigital:
 push eax
 and  al,0fh
 cmp  al,09h
 jbe  short @@this
 add  al,07h
@@this:
 add  al,30h
 call wrchr
 pop  eax
 ret
;------------------
wrhexal:
 ror  al,4
 call wrdigital
 ror  al,4
 jmp  wrdigital
;------------------
wrhexax:
 ror  ax,8
 call wrhexal
 ror  ax,8
 jmp  wrhexal
;------------------
wrhexeax:
 ror  eax,16
 call wrhexax
 ror  eax,16
 jmp  wrhexax
;------------------
;:----------------- File I/O and Memory Allocation
;------------------
alloc_databuf:
 push dword ptr [response_datasize]     ;\
 push GMEM_FIXED                        ;
 call GlobalAlloc                       ; alloc memory
 mov  dword ptr [databuffer],eax        ;
 or   eax,eax  ;memory handle           ;
;jz   short @@fail                      ;/
 ret
;------------------
free_databuf:
 mov  eax,dword ptr [databuffer]
 or   eax,eax
 jz   short @@none
 push eax  ;memory handle
 call GlobalFree
@@none:
 ret
;------------------
save_file_to_disc:
 push 0       ;for Win95 always 0       ;\
 push FILE_ATTRIBUTE_NORMAL             ;
 push CREATE_ALWAYS                     ;
 push 0       ;no Security-attributes   ;
 push 0       ;no sharing               ; create dest file
 push GENERIC_READ+GENERIC_WRITE        ;
 push offset response_filename          ;
 call CreateFileA                       ;
 mov  ebx,eax        ;filehandle        ;
 inc  eax            ;FFFFFFFFh -> zf=1 ;
;jz   short @@fail                      ;/
 push 0 ;set to 0 in most cases         ;\
 push offset diskresult  ;ptr to result ;
 push dword ptr [response_datasize]     ; write file from memory
 push dword ptr [databuffer]            ;
 push ebx  ;filehandle                  ;
 call WriteFile                         ;/
 push ebx  ;filehandle                  ;\close file
 call CloseHandle                       ;/
 clc    ;cy=0=okay
 ret
;------------------
;:----------------- Main
;------------------
start:
 push STD_OUTPUT_HANDLE         ;\
 call GetStdHandle              ;
 mov  dword ptr [std_out],eax   ;/
 mov  edx,offset txt_hello      ;\
 call wrstr_edx                 ;/
 ;- - -

 push offset wsadata                    ;\
 push 101h  ;version 1.1 (or 2.2)       ;
 call WSAStartup                        ; wsa startup
;cmp  eax,0                             ;
;jnz  short @@error                     ;/

 call find_ds                           ;-

 mov  al,byte ptr [dslink_ip_addr+0]    ;\
 call wr_decimal_al                     ;
 call wrdot                             ;
 mov  al,byte ptr [dslink_ip_addr+1]    ; show console's IP address
 call wr_decimal_al                     ;
 call wrdot                             ;
 mov  al,byte ptr [dslink_ip_addr+2]    ;
 call wr_decimal_al                     ;
 call wrdot                             ;
 mov  al,byte ptr [dslink_ip_addr+3]    ;
 call wr_decimal_al                     ;/

 call begin_tcp                         ;-

@@file_lop:
 call recv_filename                     ;\
 jc   short @@file_lop_done             ;/
 mov  edx,offset response_filename      ;\
 call wrstr_edx                         ;
 call wrcrlf                            ;/
 call alloc_databuf                     ;-
 call recv_filebody                     ;-
 call save_file_to_disc                 ;\
;jc   short @@error                     ;/
 call free_databuf                      ;-free buffer (if any)
 jmp  @@file_lop
@@file_lop_done:
 call stop_tcp                          ;-
 call WSACleanup                        ;-wsa cleanup

 push 0  ;return value          ;\terminate program
 call ExitProcess               ;/
;------------------
end start
